<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Halberd.clues.analysis</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="Halberd-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

      <th class="navbar" width="100%"></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="Halberd-module.html">Package&nbsp;Halberd</a> ::
        <a href="Halberd.clues-module.html">Package&nbsp;clues</a> ::
        Module&nbsp;analysis
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
        <tr><td align="right"><span class="options"
            >[<a href="frames.html" target="_top">frames</a
            >]&nbsp;|&nbsp;<a href="Halberd.clues.analysis-module.html"
            target="_top">no&nbsp;frames</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== MODULE DESCRIPTION ==================== -->
<h1 class="epydoc">Module analysis</h1><p class="nomargin-top"><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html">source&nbsp;code</a></span></p>
<p>Utilities for clue analysis.</p>

<!-- ==================== FUNCTIONS ==================== -->
<a name="section-Functions"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Functions</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Functions"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>list</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#diff_fields" class="summary-sig-name">diff_fields</a>(<span class="summary-sig-arg">clues</span>)</span><br />
      Study differences between fields.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#diff_fields">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#ignore_changing_fields" class="summary-sig-name">ignore_changing_fields</a>(<span class="summary-sig-arg">clues</span>)</span><br />
      Tries to detect and ignore MIME fields with ever changing content.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#ignore_changing_fields">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#get_digest" class="summary-sig-name">get_digest</a>(<span class="summary-sig-arg">clue</span>)</span><br />
      Returns the specified clue's digest.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#get_digest">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>tuple</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#clusters" class="summary-sig-name">clusters</a>(<span class="summary-sig-arg">clues</span>,
        <span class="summary-sig-arg">step</span>=<span class="summary-sig-default">3</span>)</span><br />
      Finds clusters of clues.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#clusters">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">Clue</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#merge" class="summary-sig-name">merge</a>(<span class="summary-sig-arg">clues</span>)</span><br />
      Merges a sequence of clues into one.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#merge">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>dict</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#classify" class="summary-sig-name">classify</a>(<span class="summary-sig-arg">seq</span>,
        <span class="summary-sig-arg">*classifiers</span>)</span><br />
      Classify a sequence according to one or several criteria.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#classify">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>list</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#sections" class="summary-sig-name">sections</a>(<span class="summary-sig-arg">classified</span>,
        <span class="summary-sig-arg">sects</span>=<span class="summary-sig-default">None</span>)</span><br />
      Returns sections (and their items) from a nested dict.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#sections">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>list</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#deltas" class="summary-sig-name">deltas</a>(<span class="summary-sig-arg">xs</span>)</span><br />
      Computes the differences between the elements of a sequence of 
      integers.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#deltas">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>list</code> of <code>slice</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#slices" class="summary-sig-name">slices</a>(<span class="summary-sig-arg">start</span>,
        <span class="summary-sig-arg">xs</span>)</span><br />
      Returns slices of a given sequence separated by the specified 
      indices.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#slices">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="sort_clues"></a><span class="summary-sig-name">sort_clues</span>(<span class="summary-sig-arg">clues</span>)</span><br />
      Sorts clues according to their time difference.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#sort_clues">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>list</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#filter_proxies" class="summary-sig-name">filter_proxies</a>(<span class="summary-sig-arg">clues</span>,
        <span class="summary-sig-arg">maxdelta</span>=<span class="summary-sig-default">3</span>)</span><br />
      Detect and merge clues pointing to a proxy cache on the remote end.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#filter_proxies">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>list</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#uniq" class="summary-sig-name">uniq</a>(<span class="summary-sig-arg">clues</span>)</span><br />
      Return a list of unique clues.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#uniq">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>int</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#hits" class="summary-sig-name">hits</a>(<span class="summary-sig-arg">clues</span>)</span><br />
      Compute the total number of hits in a sequence of clues.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#hits">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code>list</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#analyze" class="summary-sig-name">analyze</a>(<span class="summary-sig-arg">clues</span>)</span><br />
      Draw conclusions from the clues obtained during the scanning phase.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#analyze">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="Halberd.clues.analysis-module.html#reanalyze" class="summary-sig-name">reanalyze</a>(<span class="summary-sig-arg">clues</span>,
        <span class="summary-sig-arg">analyzed</span>,
        <span class="summary-sig-arg">threshold</span>)</span><br />
      Identify and ignore changing header fields.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#reanalyze">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_test"></a><span class="summary-sig-name">_test</span>()</span></td>
          <td align="right" valign="top">
            <span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#_test">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== VARIABLES ==================== -->
<a name="section-Variables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Variables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="logger"></a><span class="summary-name">logger</span> = <code title="Halberd.logger.getLogger()">Halberd.logger.getLogger()</code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="__package__"></a><span class="summary-name">__package__</span> = <code title="'Halberd.clues'"><code class="variable-quote">'</code><code class="variable-string">Halberd.clues</code><code class="variable-quote">'</code></code>
    </td>
  </tr>
</table>
<!-- ==================== FUNCTION DETAILS ==================== -->
<a name="section-FunctionDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Function Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-FunctionDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="diff_fields"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">diff_fields</span>(<span class="sig-arg">clues</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#diff_fields">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Study differences between fields.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code>) - Clues to analyze.</li>
    </ul></dd>
    <dt>Returns: <code>list</code></dt>
        <dd>Fields which were found to be different among the analyzed clues.</dd>
  </dl>
</td></tr></table>
</div>
<a name="ignore_changing_fields"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">ignore_changing_fields</span>(<span class="sig-arg">clues</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#ignore_changing_fields">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Tries to detect and ignore MIME fields with ever changing content.</p>
  <p>Some servers might include fields varying with time, randomly, etc. 
  Those fields are likely to alter the clue's digest and interfer with <a 
  href="Halberd.clues.analysis-module.html#analyze" 
  class="link">analyze</a>, producing many false positives and making the 
  scan useless. This function detects those fields and recalculates each 
  clue's digest so they can be safely analyzed again.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code> or <code>tuple</code>) - Sequence of clues.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="get_digest"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_digest</span>(<span class="sig-arg">clue</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#get_digest">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Returns the specified clue's digest.</p>
  <p>This function is usually passed as a parameter for <a 
  href="Halberd.clues.analysis-module.html#classify" 
  class="link">classify</a> so it can separate clues according to their 
  digest (among other fields).</p>
  <dl class="fields">
    <dt>Returns: <code>str</code></dt>
        <dd>The digest of a clue's parsed headers.</dd>
  </dl>
</td></tr></table>
</div>
<a name="clusters"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">clusters</span>(<span class="sig-arg">clues</span>,
        <span class="sig-arg">step</span>=<span class="sig-default">3</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#clusters">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Finds clusters of clues.</p>
  <p>A cluster is a group of at most <code>step</code> clues which only 
  differ in 1 seconds between each other.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code> or <code>tuple</code>) - A sequence of clues to analyze</li>
        <li><strong class="pname"><code>step</code></strong> (<code>int</code>) - Maximum difference between the time differences of the cluster's 
          clues.</li>
    </ul></dd>
    <dt>Returns: <code>tuple</code></dt>
        <dd>A sequence with merged clusters.</dd>
  </dl>
</td></tr></table>
</div>
<a name="merge"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">merge</span>(<span class="sig-arg">clues</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#merge">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Merges a sequence of clues into one.</p>
  <p>A new clue will store the total count of the clues.</p>
  <p>Note that each Clue has a starting count of 1</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>a, b, c = Clue(), Clue(), Clue()
<span class="py-prompt">&gt;&gt;&gt; </span>sum([x.getCount() <span class="py-keyword">for</span> x <span class="py-keyword">in</span> [a, b, c]])
<span class="py-output">3</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span>a.incCount(5), b.incCount(11), c.incCount(23)
<span class="py-output">(None, None, None)</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span>merged = merge((a, b, c))
<span class="py-prompt">&gt;&gt;&gt; </span>merged.getCount()
<span class="py-output">42</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span>merged == a
<span class="py-output">True</span></pre>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code> or <code>tuple</code>) - A sequence containing all the clues to merge into one.</li>
    </ul></dd>
    <dt>Returns: Clue</dt>
        <dd>The result of merging all the passed clues into one.</dd>
  </dl>
</td></tr></table>
</div>
<a name="classify"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">classify</span>(<span class="sig-arg">seq</span>,
        <span class="sig-arg">*classifiers</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#classify">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Classify a sequence according to one or several criteria.</p>
  <p>We store each item into a nested dictionary using the classifiers as 
  key generators (all of them must be callable objects).</p>
  <p>In the following example we classify a list of clues according to 
  their digest and their time difference.</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>a, b, c = Clue(), Clue(), Clue()
<span class="py-prompt">&gt;&gt;&gt; </span>a.diff, b.diff, c.diff = 1, 2, 2
<span class="py-prompt">&gt;&gt;&gt; </span>a.info[<span class="py-string">'digest'</span>] = <span class="py-string">'x'</span>
<span class="py-prompt">&gt;&gt;&gt; </span>b.info[<span class="py-string">'digest'</span>] = c.info[<span class="py-string">'digest'</span>] = <span class="py-string">'y'</span>
<span class="py-prompt">&gt;&gt;&gt; </span>get_diff = <span class="py-keyword">lambda</span> x: x.diff
<span class="py-prompt">&gt;&gt;&gt; </span>classified = classify([a, b, c], get_digest, get_diff)
<span class="py-prompt">&gt;&gt;&gt; </span>digests = classified.keys()
<span class="py-prompt">&gt;&gt;&gt; </span>digests.sort()  <span class="py-comment"># We sort these so doctest won't fail.</span>
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">for</span> digest <span class="py-keyword">in</span> digests:
<span class="py-more">... </span>    <span class="py-keyword">print</span> digest
<span class="py-more">... </span>    <span class="py-keyword">for</span> diff <span class="py-keyword">in</span> classified[digest].keys():
<span class="py-more">... </span>        <span class="py-keyword">print</span> <span class="py-string">' '</span>, diff
<span class="py-more">... </span>        <span class="py-keyword">for</span> clue <span class="py-keyword">in</span> classified[digest][diff]:
<span class="py-more">... </span>            <span class="py-keyword">if</span> clue <span class="py-keyword">is</span> a: <span class="py-keyword">print</span> <span class="py-string">'    a'</span>
<span class="py-more">... </span>            <span class="py-keyword">elif</span> clue <span class="py-keyword">is</span> b: <span class="py-keyword">print</span> <span class="py-string">'    b'</span>
<span class="py-more">... </span>            <span class="py-keyword">elif</span> clue <span class="py-keyword">is</span> c: <span class="py-keyword">print</span> <span class="py-string">'    c'</span>
<span class="py-more">...</span>
<span class="py-output">x</span>
<span class="py-output">  1</span>
<span class="py-output">    a</span>
<span class="py-output">y</span>
<span class="py-output">  2</span>
<span class="py-output">    b</span>
<span class="py-output">    c</span></pre>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>seq</code></strong> (<code>list</code> or <code>tuple</code>) - A sequence to classify.</li>
        <li><strong class="pname"><code>classifiers</code></strong> (<code>list</code> or <code>tuple</code>) - A sequence of callables which return specific fields of the items
          contained in <code class="link">seq</code></li>
    </ul></dd>
    <dt>Returns: <code>dict</code></dt>
        <dd>A nested dictionary in which the keys are the fields obtained by 
          applying the classifiers to the items in the specified sequence.</dd>
  </dl>
</td></tr></table>
</div>
<a name="sections"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">sections</span>(<span class="sig-arg">classified</span>,
        <span class="sig-arg">sects</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#sections">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Returns sections (and their items) from a nested dict.</p>
  <p>See also: <a href="Halberd.clues.analysis-module.html#classify" 
  class="link">classify</a></p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>classified</code></strong> (<code>dict</code>) - Nested dictionary.</li>
        <li><strong class="pname"><code>sects</code></strong> (<code>list</code>) - List of results. It should not be specified by the user.</li>
    </ul></dd>
    <dt>Returns: <code>list</code></dt>
        <dd>A list of lists in where each item is a subsection of a nested 
          dictionary.</dd>
  </dl>
</td></tr></table>
</div>
<a name="deltas"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">deltas</span>(<span class="sig-arg">xs</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#deltas">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Computes the differences between the elements of a sequence of 
  integers.</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>deltas([-1, 0, 1])
<span class="py-output">[1, 1]</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span>deltas([1, 1, 2, 3, 5, 8, 13])
<span class="py-output">[0, 1, 1, 2, 3, 5]</span></pre>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xs</code></strong> (<code>list</code>) - A sequence of integers.</li>
    </ul></dd>
    <dt>Returns: <code>list</code></dt>
        <dd>A list of differences between consecutive elements of <code 
          class="link">xs</code>.</dd>
  </dl>
</td></tr></table>
</div>
<a name="slices"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">slices</span>(<span class="sig-arg">start</span>,
        <span class="sig-arg">xs</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#slices">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Returns slices of a given sequence separated by the specified 
  indices.</p>
  <p>If we wanted to get the slices necessary to split range(20) in 
  sub-sequences of 5 items each we'd do:</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>seq = range(20) 
<span class="py-prompt">&gt;&gt;&gt; </span>indices = [5, 10, 15]
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">for</span> piece <span class="py-keyword">in</span> slices(0, indices):
<span class="py-more">... </span>    <span class="py-keyword">print</span> seq[piece]
<span class="py-output">[0, 1, 2, 3, 4]</span>
<span class="py-output">[5, 6, 7, 8, 9]</span>
<span class="py-output">[10, 11, 12, 13, 14]</span>
<span class="py-output">[15, 16, 17, 18, 19]</span></pre>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>start</code></strong> (<code>int</code>.) - Index of the first element of the sequence we want to partition.</li>
        <li><strong class="pname"><code>xs</code></strong> (<code>list</code>) - Sequence of indexes where 'cuts' must be made.</li>
    </ul></dd>
    <dt>Returns: <code>list</code> of <code>slice</code></dt>
        <dd>A sequence of <code>slice</code> objects suitable for splitting a
          list as specified.</dd>
  </dl>
</td></tr></table>
</div>
<a name="filter_proxies"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">filter_proxies</span>(<span class="sig-arg">clues</span>,
        <span class="sig-arg">maxdelta</span>=<span class="sig-default">3</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#filter_proxies">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Detect and merge clues pointing to a proxy cache on the remote 
  end.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code>) - Sequence of clues to analyze</li>
        <li><strong class="pname"><code>maxdelta</code></strong> (<code>int</code>) - Maximum difference allowed between a clue's time difference and 
          the previous one.</li>
    </ul></dd>
    <dt>Returns: <code>list</code></dt>
        <dd>Sequence where all irrelevant clues pointing out to proxy caches 
          have been filtered out.</dd>
  </dl>
</td></tr></table>
</div>
<a name="uniq"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">uniq</span>(<span class="sig-arg">clues</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#uniq">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Return a list of unique clues.</p>
  <p>This is needed when merging clues coming from different sources. Clues
  with the same time diff and digest are not discarded, they are merged 
  into one clue with the aggregated number of hits.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code>) - A sequence containing the clues to analyze.</li>
    </ul></dd>
    <dt>Returns: <code>list</code></dt>
        <dd>Filtered sequence of clues where no clue has the same digest and 
          time difference.</dd>
  </dl>
</td></tr></table>
</div>
<a name="hits"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">hits</span>(<span class="sig-arg">clues</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#hits">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Compute the total number of hits in a sequence of clues.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code>) - Sequence of clues.</li>
    </ul></dd>
    <dt>Returns: <code>int</code></dt>
        <dd>Total hits.</dd>
  </dl>
</td></tr></table>
</div>
<a name="analyze"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">analyze</span>(<span class="sig-arg">clues</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#analyze">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Draw conclusions from the clues obtained during the scanning 
  phase.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code>) - Unprocessed clues obtained during the scanning stage.</li>
    </ul></dd>
    <dt>Returns: <code>list</code></dt>
        <dd>Coherent list of clues identifying real web servers.</dd>
  </dl>
</td></tr></table>
</div>
<a name="reanalyze"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">reanalyze</span>(<span class="sig-arg">clues</span>,
        <span class="sig-arg">analyzed</span>,
        <span class="sig-arg">threshold</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="Halberd.clues.analysis-pysrc.html#reanalyze">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Identify and ignore changing header fields.</p>
  <p>After initial analysis one must check that there aren't as many 
  realservers as obtained clues. If there were it could be a sign of 
  something wrong happening: each clue is different from the others due to 
  one or more MIME header fields which change unexpectedly.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>clues</code></strong> (<code>list</code>) - Raw sequence of clues.</li>
        <li><strong class="pname"><code>analyzed</code></strong> (<code>list</code>) - Result from the first analysis phase.</li>
        <li><strong class="pname"><code>threshold</code></strong> (<code>float</code>) - Minimum clue-to-realserver ratio in order to trigger field 
          inspection.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="Halberd-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

      <th class="navbar" width="100%"></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sat Aug 14 15:09:27 2010
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
